POJ 3463 Sightseeing (次短路经数)
Sightseeing
| Time Limit: 2000MS | Memory Limit: 65536K | |
| Total Submissions:10005 | Accepted: 3523 |
Description
Tour operator Your Personal Holiday organises guided bus trips across the Benelux. Every day the bus moves from one city S to another city F. On this way, the tourists in the bus can see the sights alongside the route travelled. Moreover, the bus makes a number of stops (zero or more) at some beautiful cities, where the tourists get out to see the local sights.
Different groups of tourists may have different preferences for the sights they want to see, and thus for the route to be taken from S to F. Therefore, Your Personal Holiday wants to offer its clients a choice from many different routes. As hotels have been booked in advance, the starting city S and the final city F, though, are fixed. Two routes from S to F are considered different if there is at least one road from a city A to a city B which is part of one route, but not of the other route.
There is a restriction on the routes that the tourists may choose from. To leave enough time for the sightseeing at the stops (and to avoid using too much fuel), the bus has to take a short route from S to F. It has to be either a route with minimal distance, or a route which is one distance unit longer than the minimal distance. Indeed, by allowing routes that are one distance unit longer, the tourists may have more choice than by restricting them to exactly the minimal routes. This enhances the impression of a personal holiday.

For example, for the above road map, there are two minimal routes from S = 1 to F = 5: 1 → 2 → 5 and 1 → 3 → 5, both of length 6. There is one route that is one distance unit longer: 1 → 3 → 4 → 5, of length 7.
Now, given a (partial) road map of the Benelux and two cities S and F, tour operator Your Personal Holiday likes to know how many different routes it can offer to its clients, under the above restriction on the route length.
Input
The first line of the input file contains a single number: the number of test cases to follow. Each test case has the following format:
One line with two integers N and M, separated by a single space, with 2 ≤ N ≤ 1,000 and 1 ≤ M ≤ 10, 000: the number of cities and the number of roads in the road map.
M lines, each with three integers A, B and L, separated by single spaces, with 1 ≤ A, B ≤ N, A ≠ B and 1 ≤ L ≤ 1,000, describing a road from city A to city B with length L.
The roads are unidirectional. Hence, if there is a road from A to B, then there is not necessarily also a road from B to A. There may be different roads from a city A to a city B.
One line with two integers S and F, separated by a single space, with 1 ≤ S, F ≤ N and S ≠ F: the starting city and the final city of the route.
There will be at least one route from S to F.
Output
For every test case in the input file, the output should contain a single number, on a single line: the number of routes of minimal length or one distance unit longer. Test cases are such, that this number is at most 109 = 1,000,000,000.
Sample Input
2
5 8
1 2 3
1 3 2
1 4 5
2 3 1
2 5 3
3 4 2
3 5 4
4 5 3
1 5
5 6
2 3 1
3 2 1
3 1 10
4 5 2
5 2 7
5 2 7
4 1
Sample Output
3
2
Hint
The first test case above corresponds to the picture in the problem description.
思路
一开始我想了一下,用A*好像可以做,但是超了内存,看了一下discuss,原因应该是不断入队造成的,这让我感到十分无奈,毕竟刚刚才用a*过了一题。
具体的东西我写在注释里了,注意次短路的入队操作!
#include<iostream>
#include<vector>
#include<queue>
#include<cstdio>
#include<cstring>
using namespace std;
typedef long long ll;
const ll inf = 210000000000000;
int n,m,s,t;
vector<int>u[1024];
vector<ll>w[1024];
ll dis[1024][2];
//虽然按照我的推理,这个题不会爆int ,可是不用int,就是会wa;
bool book[1024][2];
ll ans[1024][2];
struct node
{
int num;
ll dis;
int flag;
bool operator<(const node x)const
{
return x.dis<dis;
}
}; ll Dijkstra()
{
priority_queue<node>q;
node exa;
dis[s][0]=0;ans[s][0]=1;
q.push(node{s,0,0});
while(!q.empty()){
exa=q.top();q.pop();
int st = exa.num;//当前起点
ll diss=exa.dis;//diss表示,当前节点的最短(或次短)
int f=exa.flag;//表示这是最短还是次短
if(book[st][f]){continue;}
book[st][f]=true;
int siz=u[st].size();
for(int i=0;i<siz;i++){
int y=u[st][i];
ll ww=w[st][i];
/*y是下一个节点,ww是路径*/
if(dis[y][0]>diss+ww){//最短的距离可以更新
q.push(node{y,dis[y][0],1});
dis[y][1]=dis[y][0];//下一节点的次短路,就是更新前的最短路
ans[y][1]=ans[y][0];//下一节点的次短路条数,就是更新前的最短路条数
dis[y][0]=diss+ww;//更新最短路
ans[y][0]=ans[st][0];//下一最短路的条数,就是当前节点最短/次短的条数
//这个位置不可能是次短路更新
q.push(node{y,diss+ww,0});
}
else if(dis[y][0]==diss+ww){//下一节点的最短距离,就是当前距离
ans[y][0]+=ans[st][0];
}
else if(dis[y][1]>diss+ww){//次短路可更新
dis[y][1]=diss+ww;//更新次短路
ans[y][1]=ans[st][f];//下一节点的次短路条数,就是更新来源的路径数
q.push(node{y,diss+ww,1});
}
else if(dis[y][1]==diss+ww){
ans[y][1]+=ans[st][f];//下一节点的路径数,加上当前节点的路径数
}
}
}
if(dis[t][1]==dis[t][0]+1){
return ans[t][0]+ans[t][1];
}
return ans[t][0];
} void init()
{
for(int i=0;i<=n+1;i++){
for(int j=0;j<=1;j++){
dis[i][j]=inf;
}
}
memset(book,0,sizeof(book));
memset(ans,0,sizeof(ans));
for(int i=1;i<=n;i++){
u[i].clear();
w[i].clear();
}
} int main()
{
int T;
scanf("%d",&T);
while(T--){
scanf("%d%d",&n,&m);
init();
int x,y;ll z;
for(int i=1;i<=m;i++){
scanf("%d%d%lld",&x,&y,&z);
u[x].push_back(y);
w[x].push_back(z);
}
scanf("%d%d",&s,&t);
printf("%lld\n",Dijkstra());
}
}
妈呀,wa死我了,a个题真不容易
POJ 3463 Sightseeing (次短路经数)的更多相关文章
- poj 3463 Sightseeing(次短路+条数统计)
/* 对dij的再一次理解 每个点依旧永久标记 只不过这里多搞一维 0 1 表示最短路还是次短路 然后更新次数相当于原来的两倍 更新的时候搞一下就好了 */ #include<iostream& ...
- poj 3463 Sightseeing( 最短路与次短路)
http://poj.org/problem?id=3463 Sightseeing Time Limit: 2000MS Memory Limit: 65536K Total Submissio ...
- POJ - 3463 Sightseeing 最短路计数+次短路计数
F - Sightseeing 传送门: POJ - 3463 分析 一句话题意:给你一个有向图,可能有重边,让你求从s到t最短路的条数,如果次短路的长度比最短路的长度多1,那么在加上次短路的条数. ...
- POJ 3463 Sightseeing (次短路)
题意:求两点之间最短路的数目加上比最短路长度大1的路径数目 分析:可以转化为求最短路和次短路的问题,如果次短路比最短路大1,那么结果就是最短路数目加上次短路数目,否则就不加. 求解次短路的过程也是基于 ...
- poj 3463 Sightseeing——次短路计数
题目:http://poj.org/problem?id=3463 当然要给一个点记最短路和次短路的长度和方案. 但往优先队列里放的结构体和vis竟然也要区分0/1,就像把一个点拆成两个点了一样. 不 ...
- POJ 3463 Sightseeing
最短路+次短路(Dijkstra+priority_queue) 题意是要求你找出最短路的条数+与最短路仅仅差1的次短路的条数. 開始仅仅会算最短路的条数,和次短路的长度.真是给次短路条数跪了.ORZ ...
- POJ 3463 Sightseeing 【最短路与次短路】
题目 Tour operator Your Personal Holiday organises guided bus trips across the Benelux. Every day the ...
- POJ 3463 Sightseeing 题解
题目 Tour operator Your Personal Holiday organises guided bus trips across the Benelux. Every day the ...
- POJ 3463 最(次)短路条数
Sightseeing Time Limit: 2000MS Memory Limit: 65536K Total Submissions: 9497 Accepted: 3340 Descr ...
随机推荐
- thinkphp视图中插入php代码
性别: <?php if($item['sex'] == 1):?> 男 <?php else:?> 女 <?php endif;?> 错误:<?php ec ...
- css的特性
一.继承性: 继承是一种规则,它允许样式不仅应用于某个特定html标签元素,而且应用于其后代. /* 不具有继承性的css样式: */p{border:1px solid red;} 二.特殊性(优先 ...
- 跳转语句之continue
js里面有两个跳转语句,一个是continue,一个是break.由于这两个跳转语句都是用于循环当中,因此他们也就只能用于while.for.do…while语句中,当然了,break多加一个swit ...
- canvas图形绘制
前面的话 前面分别介绍了canvas的基础用法和进阶用法,本文将使用canvas的各种语法进行图形绘制 绘制线条 [绘制线条] 下面来尝试绘制一段线条 <canvas id="draw ...
- Linux vmstat命令
vmstat命令是最常见的Linux/Unix监控工具,可以展现给定时间间隔的服务器的状态值,包括服务器的CPU使用率,内存使用,虚拟内存交换情况,IO读写情况.这个命令是我查看Linux/Unix最 ...
- myclipse里有感叹号的问题,希望可以帮到各位
今天,我在myeclipse中导入一个项目的时候就发现一个问题:项目有红色感叹号,并且项目有红色错误提示.我首先看了这个红色错误提示的地方,发现这个根本不应该报错,想必是这个红色感叹号的原因. 于 ...
- HDU 1021 斐波那契
参考自:https://www.cnblogs.com/ECJTUACM-873284962/p/6404504.html Fibonacci Again Time Limit: 2000/1000 ...
- MT【268】投篮第一次很重要
已知 $r_1=0,r_{100}=0.85,(r_k$ 表示投 k 次投中的概率.)求证:(1)是否存在$n_0$使得$r_{n_0}=0.5$ (2)是否存在$n_1$使得$r_{n_1}=0.8 ...
- 树莓派(Raspberry Pi)使用Shell编写的极简Service
树莓派(Raspberry Pi)运行的系统是基于Debian的,不仅可以运行Shell,还支持systemd和docker,可以编写一个简单的服务,让其在启动时运行,执行一些自动化的操作.这里在Ra ...
- Netty如何实现Reactor模式
在前面的文章中(Reactor模型详解),我们讲解了Reactor模式的各种演变形式,本文主要讲解的则是Netty是如何实现Reactor模式的.这里关于Netty实现的Reactor模式,需要说明的 ...